<template>
  <div class="all-process"> 
    <mt-header fixed :title="$t('more')">
      <router-link to="/" slot="left">
        <mt-button icon="back"></mt-button>
      </router-link>
    </mt-header>
    <div class="spaceHeader"></div>
    <div>
      <div v-for="mode in modes" :key="mode.id" class="launchCon">
        <div>
          <div class="launch-partHeader">{{mode.description}}</div>
            <template v-for="menu in startmenus">
              <div v-if="menu.parent == mode.id" :key="menu.id" class="launch-flex">
              <span class="launch-flexSpan">
                <div>
                  <div class="flow-name">
                    <img class="menu-img" :src="contextPath + menu.ico.icon + aToken" v-if="menu.ico != null && menu.ico.icontype == 'img'"/>
                    <i :class="'menu-font fa-2x '+ menu.ico.icon" :style="{color: menu.ico.iconFontColor}" v-if="menu.ico != null && menu.ico.icontype == 'font'"></i>
                    <img class="menu-img" src="../assets/images/defaultMenu.png" v-if="menu.ico == null"/>
                    <div class="menu-description">{{menu.description}}</div>
                  </div>
                  <div class="flow-operate">
                    <mt-button v-if="!menu.usual" size="small" type="primary" @click="onAddClick(menu)">{{$t('add')}}</mt-button>
                    <mt-button v-if="menu.usual" size="small" type="primary" plain @click="onRemoveClick(menu)">{{$t('remove')}}</mt-button>
                  </div>
                </div>
              </span>
              </div>
            </template>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import API from "@/api.js";
import Constant from "@/Constant.js";
export default {
  name:'favoritesFunc',
  created() {
    this.aToken = "?accessToken=" + localStorage.getItem("accessToken")
    this.contextPath = obpmConfig.obpmFilePath;
    API.getLaunchMenu(this.$root.appid, false, true,{
      onSucess: response => {
        this.startmenus = response.data.data;
      }
    })
  },
  beforeRouteLeave(to, from, next) {
    from.meta.keepAlive = false;
    next();
  },
  computed: {
    modes() {
      let modes = [];
      if (this.startmenus)
        this.startmenus.forEach(menu => {
          if (menu.parent == this.$root.appid) {
            modes.push({
              id: menu.id,
              description: menu.description
            });
          }
        });
      return modes;
    }
  },
  data: function() {
    return {
      startmenus: [],
      Constant,
      addMenu:false,
      contextPath: '',
      aToken:''
    };
  },
  methods: {
    onAddClick(menu){
      this.addMenu = true;
      API.addMenuToFavorites(this.$root.appid, menu.id, {onSucess: response=>{
        if (response.data.errcode == 0)
          menu.usual = true;
      }});
    },

    onRemoveClick(menu){
      API.removeMenuFromFavorites(this.$root.appid, menu.id, {onSucess: response=>{
        if (response.data.errcode == 0)
          menu.usual = false;
      }});
    },

  }
};
</script>
